package net.sf.jasperreports.engine.fill;

class JRShortStandardDeviationIncrementer extends JRAbstractExtendedIncrementer {
  private static JRShortStandardDeviationIncrementer mainInstance = new JRShortStandardDeviationIncrementer();
  
  public static JRShortStandardDeviationIncrementer getInstance() {
    return mainInstance;
  }
  
  public Object increment(JRCalculable variable, Object expressionValue, AbstractValueProvider valueProvider) {
    if (expressionValue == null) {
      if (variable.isInitialized())
        return null; 
      return variable.getValue();
    } 
    Number varianceValue = (Number)valueProvider.getValue(variable.getHelperVariable((byte)2));
    return new Short((short)(int)Math.sqrt(varianceValue.doubleValue()));
  }
  
  public Object initialValue() {
    return JRShortIncrementerFactory.ZERO;
  }
}
